# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.paging import Paged


class ApiContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ApiContract <azure.mgmt.apimanagement.models.ApiContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ApiContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(ApiContractPaged, self).__init__(*args, **kwargs)
class TagResourceContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`TagResourceContract <azure.mgmt.apimanagement.models.TagResourceContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[TagResourceContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(TagResourceContractPaged, self).__init__(*args, **kwargs)
class ApiRevisionContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ApiRevisionContract <azure.mgmt.apimanagement.models.ApiRevisionContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ApiRevisionContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(ApiRevisionContractPaged, self).__init__(*args, **kwargs)
class ApiReleaseContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ApiReleaseContract <azure.mgmt.apimanagement.models.ApiReleaseContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ApiReleaseContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(ApiReleaseContractPaged, self).__init__(*args, **kwargs)
class OperationContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`OperationContract <azure.mgmt.apimanagement.models.OperationContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[OperationContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(OperationContractPaged, self).__init__(*args, **kwargs)
class TagContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`TagContract <azure.mgmt.apimanagement.models.TagContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[TagContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(TagContractPaged, self).__init__(*args, **kwargs)
class ProductContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ProductContract <azure.mgmt.apimanagement.models.ProductContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ProductContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(ProductContractPaged, self).__init__(*args, **kwargs)
class SchemaContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`SchemaContract <azure.mgmt.apimanagement.models.SchemaContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[SchemaContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(SchemaContractPaged, self).__init__(*args, **kwargs)
class DiagnosticContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`DiagnosticContract <azure.mgmt.apimanagement.models.DiagnosticContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[DiagnosticContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(DiagnosticContractPaged, self).__init__(*args, **kwargs)
class IssueContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`IssueContract <azure.mgmt.apimanagement.models.IssueContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[IssueContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(IssueContractPaged, self).__init__(*args, **kwargs)
class IssueCommentContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`IssueCommentContract <azure.mgmt.apimanagement.models.IssueCommentContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[IssueCommentContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(IssueCommentContractPaged, self).__init__(*args, **kwargs)
class IssueAttachmentContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`IssueAttachmentContract <azure.mgmt.apimanagement.models.IssueAttachmentContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[IssueAttachmentContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(IssueAttachmentContractPaged, self).__init__(*args, **kwargs)
class TagDescriptionContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`TagDescriptionContract <azure.mgmt.apimanagement.models.TagDescriptionContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[TagDescriptionContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(TagDescriptionContractPaged, self).__init__(*args, **kwargs)
class ApiVersionSetContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ApiVersionSetContract <azure.mgmt.apimanagement.models.ApiVersionSetContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ApiVersionSetContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(ApiVersionSetContractPaged, self).__init__(*args, **kwargs)
class AuthorizationServerContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`AuthorizationServerContract <azure.mgmt.apimanagement.models.AuthorizationServerContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[AuthorizationServerContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(AuthorizationServerContractPaged, self).__init__(*args, **kwargs)
class BackendContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`BackendContract <azure.mgmt.apimanagement.models.BackendContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[BackendContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(BackendContractPaged, self).__init__(*args, **kwargs)
class CacheContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`CacheContract <azure.mgmt.apimanagement.models.CacheContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[CacheContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(CacheContractPaged, self).__init__(*args, **kwargs)
class CertificateContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`CertificateContract <azure.mgmt.apimanagement.models.CertificateContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[CertificateContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(CertificateContractPaged, self).__init__(*args, **kwargs)
class OperationPaged(Paged):
    """
    A paging container for iterating over a list of :class:`Operation <azure.mgmt.apimanagement.models.Operation>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Operation]'}
    }

    def __init__(self, *args, **kwargs):

        super(OperationPaged, self).__init__(*args, **kwargs)
class ResourceSkuResultPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ResourceSkuResult <azure.mgmt.apimanagement.models.ResourceSkuResult>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ResourceSkuResult]'}
    }

    def __init__(self, *args, **kwargs):

        super(ResourceSkuResultPaged, self).__init__(*args, **kwargs)
class ApiManagementServiceResourcePaged(Paged):
    """
    A paging container for iterating over a list of :class:`ApiManagementServiceResource <azure.mgmt.apimanagement.models.ApiManagementServiceResource>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ApiManagementServiceResource]'}
    }

    def __init__(self, *args, **kwargs):

        super(ApiManagementServiceResourcePaged, self).__init__(*args, **kwargs)
class EmailTemplateContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`EmailTemplateContract <azure.mgmt.apimanagement.models.EmailTemplateContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[EmailTemplateContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(EmailTemplateContractPaged, self).__init__(*args, **kwargs)
class GatewayContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`GatewayContract <azure.mgmt.apimanagement.models.GatewayContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[GatewayContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(GatewayContractPaged, self).__init__(*args, **kwargs)
class GatewayHostnameConfigurationContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`GatewayHostnameConfigurationContract <azure.mgmt.apimanagement.models.GatewayHostnameConfigurationContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[GatewayHostnameConfigurationContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(GatewayHostnameConfigurationContractPaged, self).__init__(*args, **kwargs)
class GroupContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`GroupContract <azure.mgmt.apimanagement.models.GroupContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[GroupContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(GroupContractPaged, self).__init__(*args, **kwargs)
class UserContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`UserContract <azure.mgmt.apimanagement.models.UserContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[UserContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(UserContractPaged, self).__init__(*args, **kwargs)
class IdentityProviderContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`IdentityProviderContract <azure.mgmt.apimanagement.models.IdentityProviderContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[IdentityProviderContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(IdentityProviderContractPaged, self).__init__(*args, **kwargs)
class LoggerContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`LoggerContract <azure.mgmt.apimanagement.models.LoggerContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[LoggerContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(LoggerContractPaged, self).__init__(*args, **kwargs)
class NamedValueContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`NamedValueContract <azure.mgmt.apimanagement.models.NamedValueContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[NamedValueContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(NamedValueContractPaged, self).__init__(*args, **kwargs)
class NotificationContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`NotificationContract <azure.mgmt.apimanagement.models.NotificationContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[NotificationContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(NotificationContractPaged, self).__init__(*args, **kwargs)
class OpenidConnectProviderContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`OpenidConnectProviderContract <azure.mgmt.apimanagement.models.OpenidConnectProviderContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[OpenidConnectProviderContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(OpenidConnectProviderContractPaged, self).__init__(*args, **kwargs)
class SubscriptionContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`SubscriptionContract <azure.mgmt.apimanagement.models.SubscriptionContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[SubscriptionContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(SubscriptionContractPaged, self).__init__(*args, **kwargs)
class RegionContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`RegionContract <azure.mgmt.apimanagement.models.RegionContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[RegionContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(RegionContractPaged, self).__init__(*args, **kwargs)
class ReportRecordContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ReportRecordContract <azure.mgmt.apimanagement.models.ReportRecordContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ReportRecordContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(ReportRecordContractPaged, self).__init__(*args, **kwargs)
class RequestReportRecordContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`RequestReportRecordContract <azure.mgmt.apimanagement.models.RequestReportRecordContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[RequestReportRecordContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(RequestReportRecordContractPaged, self).__init__(*args, **kwargs)
class UserIdentityContractPaged(Paged):
    """
    A paging container for iterating over a list of :class:`UserIdentityContract <azure.mgmt.apimanagement.models.UserIdentityContract>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[UserIdentityContract]'}
    }

    def __init__(self, *args, **kwargs):

        super(UserIdentityContractPaged, self).__init__(*args, **kwargs)
