# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

try:
    from .container_port_py3 import ContainerPort
    from .environment_variable_py3 import EnvironmentVariable
    from .container_state_py3 import ContainerState
    from .event_py3 import Event
    from .container_properties_instance_view_py3 import ContainerPropertiesInstanceView
    from .gpu_resource_py3 import GpuResource
    from .resource_requests_py3 import ResourceRequests
    from .resource_limits_py3 import ResourceLimits
    from .resource_requirements_py3 import ResourceRequirements
    from .volume_mount_py3 import VolumeMount
    from .container_exec_py3 import ContainerExec
    from .container_http_get_py3 import ContainerHttpGet
    from .container_probe_py3 import ContainerProbe
    from .container_py3 import Container
    from .azure_file_volume_py3 import AzureFileVolume
    from .git_repo_volume_py3 import GitRepoVolume
    from .volume_py3 import Volume
    from .container_group_identity_user_assigned_identities_value_py3 import ContainerGroupIdentityUserAssignedIdentitiesValue
    from .container_group_identity_py3 import ContainerGroupIdentity
    from .image_registry_credential_py3 import ImageRegistryCredential
    from .port_py3 import Port
    from .ip_address_py3 import IpAddress
    from .container_group_properties_instance_view_py3 import ContainerGroupPropertiesInstanceView
    from .log_analytics_py3 import LogAnalytics
    from .container_group_diagnostics_py3 import ContainerGroupDiagnostics
    from .container_group_network_profile_py3 import ContainerGroupNetworkProfile
    from .dns_configuration_py3 import DnsConfiguration
    from .container_group_py3 import ContainerGroup
    from .operation_display_py3 import OperationDisplay
    from .operation_py3 import Operation
    from .operation_list_result_py3 import OperationListResult
    from .usage_name_py3 import UsageName
    from .usage_py3 import Usage
    from .usage_list_result_py3 import UsageListResult
    from .logs_py3 import Logs
    from .container_exec_request_terminal_size_py3 import ContainerExecRequestTerminalSize
    from .container_exec_request_py3 import ContainerExecRequest
    from .container_exec_response_py3 import ContainerExecResponse
    from .resource_py3 import Resource
    from .cached_images_py3 import CachedImages
    from .cached_images_list_result_py3 import CachedImagesListResult
    from .capabilities_capabilities_py3 import CapabilitiesCapabilities
    from .capabilities_py3 import Capabilities
    from .capabilities_list_result_py3 import CapabilitiesListResult
except (SyntaxError, ImportError):
    from .container_port import ContainerPort
    from .environment_variable import EnvironmentVariable
    from .container_state import ContainerState
    from .event import Event
    from .container_properties_instance_view import ContainerPropertiesInstanceView
    from .gpu_resource import GpuResource
    from .resource_requests import ResourceRequests
    from .resource_limits import ResourceLimits
    from .resource_requirements import ResourceRequirements
    from .volume_mount import VolumeMount
    from .container_exec import ContainerExec
    from .container_http_get import ContainerHttpGet
    from .container_probe import ContainerProbe
    from .container import Container
    from .azure_file_volume import AzureFileVolume
    from .git_repo_volume import GitRepoVolume
    from .volume import Volume
    from .container_group_identity_user_assigned_identities_value import ContainerGroupIdentityUserAssignedIdentitiesValue
    from .container_group_identity import ContainerGroupIdentity
    from .image_registry_credential import ImageRegistryCredential
    from .port import Port
    from .ip_address import IpAddress
    from .container_group_properties_instance_view import ContainerGroupPropertiesInstanceView
    from .log_analytics import LogAnalytics
    from .container_group_diagnostics import ContainerGroupDiagnostics
    from .container_group_network_profile import ContainerGroupNetworkProfile
    from .dns_configuration import DnsConfiguration
    from .container_group import ContainerGroup
    from .operation_display import OperationDisplay
    from .operation import Operation
    from .operation_list_result import OperationListResult
    from .usage_name import UsageName
    from .usage import Usage
    from .usage_list_result import UsageListResult
    from .logs import Logs
    from .container_exec_request_terminal_size import ContainerExecRequestTerminalSize
    from .container_exec_request import ContainerExecRequest
    from .container_exec_response import ContainerExecResponse
    from .resource import Resource
    from .cached_images import CachedImages
    from .cached_images_list_result import CachedImagesListResult
    from .capabilities_capabilities import CapabilitiesCapabilities
    from .capabilities import Capabilities
    from .capabilities_list_result import CapabilitiesListResult
from .container_group_paged import ContainerGroupPaged
from .container_instance_management_client_enums import (
    ContainerNetworkProtocol,
    GpuSku,
    ResourceIdentityType,
    ContainerGroupRestartPolicy,
    ContainerGroupNetworkProtocol,
    ContainerGroupIpAddressType,
    OperatingSystemTypes,
    LogAnalyticsLogType,
    ContainerInstanceOperationsOrigin,
)

__all__ = [
    'ContainerPort',
    'EnvironmentVariable',
    'ContainerState',
    'Event',
    'ContainerPropertiesInstanceView',
    'GpuResource',
    'ResourceRequests',
    'ResourceLimits',
    'ResourceRequirements',
    'VolumeMount',
    'ContainerExec',
    'ContainerHttpGet',
    'ContainerProbe',
    'Container',
    'AzureFileVolume',
    'GitRepoVolume',
    'Volume',
    'ContainerGroupIdentityUserAssignedIdentitiesValue',
    'ContainerGroupIdentity',
    'ImageRegistryCredential',
    'Port',
    'IpAddress',
    'ContainerGroupPropertiesInstanceView',
    'LogAnalytics',
    'ContainerGroupDiagnostics',
    'ContainerGroupNetworkProfile',
    'DnsConfiguration',
    'ContainerGroup',
    'OperationDisplay',
    'Operation',
    'OperationListResult',
    'UsageName',
    'Usage',
    'UsageListResult',
    'Logs',
    'ContainerExecRequestTerminalSize',
    'ContainerExecRequest',
    'ContainerExecResponse',
    'Resource',
    'CachedImages',
    'CachedImagesListResult',
    'CapabilitiesCapabilities',
    'Capabilities',
    'CapabilitiesListResult',
    'ContainerGroupPaged',
    'ContainerNetworkProtocol',
    'GpuSku',
    'ResourceIdentityType',
    'ContainerGroupRestartPolicy',
    'ContainerGroupNetworkProtocol',
    'ContainerGroupIpAddressType',
    'OperatingSystemTypes',
    'LogAnalyticsLogType',
    'ContainerInstanceOperationsOrigin',
]
