# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.service_client import SDKClient
from msrest import Serializer, Deserializer

from ._configuration import EventGridManagementClientConfiguration
from .operations import DomainsOperations
from .operations import DomainTopicsOperations
from .operations import EventChannelsOperations
from .operations import EventSubscriptionsOperations
from .operations import SystemTopicEventSubscriptionsOperations
from .operations import PartnerTopicEventSubscriptionsOperations
from .operations import Operations
from .operations import PartnerNamespacesOperations
from .operations import PartnerRegistrationsOperations
from .operations import PartnerTopicsOperations
from .operations import PrivateEndpointConnectionsOperations
from .operations import PrivateLinkResourcesOperations
from .operations import SystemTopicsOperations
from .operations import TopicsOperations
from .operations import ExtensionTopicsOperations
from .operations import TopicTypesOperations
from . import models


class EventGridManagementClient(SDKClient):
    """Azure EventGrid Management Client

    :ivar config: Configuration for client.
    :vartype config: EventGridManagementClientConfiguration

    :ivar domains: Domains operations
    :vartype domains: azure.mgmt.eventgrid.operations.DomainsOperations
    :ivar domain_topics: DomainTopics operations
    :vartype domain_topics: azure.mgmt.eventgrid.operations.DomainTopicsOperations
    :ivar event_channels: EventChannels operations
    :vartype event_channels: azure.mgmt.eventgrid.operations.EventChannelsOperations
    :ivar event_subscriptions: EventSubscriptions operations
    :vartype event_subscriptions: azure.mgmt.eventgrid.operations.EventSubscriptionsOperations
    :ivar system_topic_event_subscriptions: SystemTopicEventSubscriptions operations
    :vartype system_topic_event_subscriptions: azure.mgmt.eventgrid.operations.SystemTopicEventSubscriptionsOperations
    :ivar partner_topic_event_subscriptions: PartnerTopicEventSubscriptions operations
    :vartype partner_topic_event_subscriptions: azure.mgmt.eventgrid.operations.PartnerTopicEventSubscriptionsOperations
    :ivar operations: Operations operations
    :vartype operations: azure.mgmt.eventgrid.operations.Operations
    :ivar partner_namespaces: PartnerNamespaces operations
    :vartype partner_namespaces: azure.mgmt.eventgrid.operations.PartnerNamespacesOperations
    :ivar partner_registrations: PartnerRegistrations operations
    :vartype partner_registrations: azure.mgmt.eventgrid.operations.PartnerRegistrationsOperations
    :ivar partner_topics: PartnerTopics operations
    :vartype partner_topics: azure.mgmt.eventgrid.operations.PartnerTopicsOperations
    :ivar private_endpoint_connections: PrivateEndpointConnections operations
    :vartype private_endpoint_connections: azure.mgmt.eventgrid.operations.PrivateEndpointConnectionsOperations
    :ivar private_link_resources: PrivateLinkResources operations
    :vartype private_link_resources: azure.mgmt.eventgrid.operations.PrivateLinkResourcesOperations
    :ivar system_topics: SystemTopics operations
    :vartype system_topics: azure.mgmt.eventgrid.operations.SystemTopicsOperations
    :ivar topics: Topics operations
    :vartype topics: azure.mgmt.eventgrid.operations.TopicsOperations
    :ivar extension_topics: ExtensionTopics operations
    :vartype extension_topics: azure.mgmt.eventgrid.operations.ExtensionTopicsOperations
    :ivar topic_types: TopicTypes operations
    :vartype topic_types: azure.mgmt.eventgrid.operations.TopicTypesOperations

    :param credentials: Credentials needed for the client to connect to Azure.
    :type credentials: :mod:`A msrestazure Credentials
     object<msrestazure.azure_active_directory>`
    :param subscription_id: Subscription credentials that uniquely identify a
     Microsoft Azure subscription. The subscription ID forms part of the URI
     for every service call.
    :type subscription_id: str
    :param str base_url: Service URL
    """

    def __init__(
            self, credentials, subscription_id, base_url=None):

        self.config = EventGridManagementClientConfiguration(credentials, subscription_id, base_url)
        super(EventGridManagementClient, self).__init__(self.config.credentials, self.config)

        client_models = {k: v for k, v in models.__dict__.items() if isinstance(v, type)}
        self.api_version = '2020-04-01-preview'
        self._serialize = Serializer(client_models)
        self._deserialize = Deserializer(client_models)

        self.domains = DomainsOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.domain_topics = DomainTopicsOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.event_channels = EventChannelsOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.event_subscriptions = EventSubscriptionsOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.system_topic_event_subscriptions = SystemTopicEventSubscriptionsOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.partner_topic_event_subscriptions = PartnerTopicEventSubscriptionsOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.operations = Operations(
            self._client, self.config, self._serialize, self._deserialize)
        self.partner_namespaces = PartnerNamespacesOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.partner_registrations = PartnerRegistrationsOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.partner_topics = PartnerTopicsOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.private_endpoint_connections = PrivateEndpointConnectionsOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.private_link_resources = PrivateLinkResourcesOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.system_topics = SystemTopicsOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.topics = TopicsOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.extension_topics = ExtensionTopicsOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.topic_types = TopicTypesOperations(
            self._client, self.config, self._serialize, self._deserialize)
