# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

try:
    from ._models_py3 import AccessKeys
    from ._models_py3 import ArmDisasterRecovery
    from ._models_py3 import AuthorizationRule
    from ._models_py3 import CaptureDescription
    from ._models_py3 import CheckNameAvailabilityParameter
    from ._models_py3 import CheckNameAvailabilityResult
    from ._models_py3 import ConsumerGroup
    from ._models_py3 import Destination
    from ._models_py3 import EHNamespace
    from ._models_py3 import ErrorResponse, ErrorResponseException
    from ._models_py3 import Eventhub
    from ._models_py3 import MessagingPlan
    from ._models_py3 import MessagingRegions
    from ._models_py3 import MessagingRegionsProperties
    from ._models_py3 import NetworkRuleSet
    from ._models_py3 import NWRuleSetIpRules
    from ._models_py3 import NWRuleSetVirtualNetworkRules
    from ._models_py3 import Operation
    from ._models_py3 import OperationDisplay
    from ._models_py3 import RegenerateAccessKeyParameters
    from ._models_py3 import Resource
    from ._models_py3 import Sku
    from ._models_py3 import Subnet
    from ._models_py3 import TrackedResource
except (SyntaxError, ImportError):
    from ._models import AccessKeys
    from ._models import ArmDisasterRecovery
    from ._models import AuthorizationRule
    from ._models import CaptureDescription
    from ._models import CheckNameAvailabilityParameter
    from ._models import CheckNameAvailabilityResult
    from ._models import ConsumerGroup
    from ._models import Destination
    from ._models import EHNamespace
    from ._models import ErrorResponse, ErrorResponseException
    from ._models import Eventhub
    from ._models import MessagingPlan
    from ._models import MessagingRegions
    from ._models import MessagingRegionsProperties
    from ._models import NetworkRuleSet
    from ._models import NWRuleSetIpRules
    from ._models import NWRuleSetVirtualNetworkRules
    from ._models import Operation
    from ._models import OperationDisplay
    from ._models import RegenerateAccessKeyParameters
    from ._models import Resource
    from ._models import Sku
    from ._models import Subnet
    from ._models import TrackedResource
from ._paged_models import ArmDisasterRecoveryPaged
from ._paged_models import AuthorizationRulePaged
from ._paged_models import ConsumerGroupPaged
from ._paged_models import EHNamespacePaged
from ._paged_models import EventhubPaged
from ._paged_models import MessagingRegionsPaged
from ._paged_models import NetworkRuleSetPaged
from ._paged_models import OperationPaged
from ._event_hub_management_client_enums import (
    AccessRights,
    KeyType,
    UnavailableReason,
    ProvisioningStateDR,
    RoleDisasterRecovery,
    EncodingCaptureDescription,
    EntityStatus,
    SkuName,
    SkuTier,
    NetworkRuleIPAction,
    DefaultAction,
)

__all__ = [
    'AccessKeys',
    'ArmDisasterRecovery',
    'AuthorizationRule',
    'CaptureDescription',
    'CheckNameAvailabilityParameter',
    'CheckNameAvailabilityResult',
    'ConsumerGroup',
    'Destination',
    'EHNamespace',
    'ErrorResponse', 'ErrorResponseException',
    'Eventhub',
    'MessagingPlan',
    'MessagingRegions',
    'MessagingRegionsProperties',
    'NetworkRuleSet',
    'NWRuleSetIpRules',
    'NWRuleSetVirtualNetworkRules',
    'Operation',
    'OperationDisplay',
    'RegenerateAccessKeyParameters',
    'Resource',
    'Sku',
    'Subnet',
    'TrackedResource',
    'AuthorizationRulePaged',
    'EHNamespacePaged',
    'NetworkRuleSetPaged',
    'ArmDisasterRecoveryPaged',
    'EventhubPaged',
    'ConsumerGroupPaged',
    'OperationPaged',
    'MessagingRegionsPaged',
    'AccessRights',
    'KeyType',
    'UnavailableReason',
    'ProvisioningStateDR',
    'RoleDisasterRecovery',
    'EncodingCaptureDescription',
    'EntityStatus',
    'SkuName',
    'SkuTier',
    'NetworkRuleIPAction',
    'DefaultAction',
]
