# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.paging import Paged


class SitePaged(Paged):
    """
    A paging container for iterating over a list of :class:`Site <azure.mgmt.web.v2016_08_01.models.Site>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Site]'}
    }

    def __init__(self, *args, **kwargs):

        super(SitePaged, self).__init__(*args, **kwargs)
class BackupItemPaged(Paged):
    """
    A paging container for iterating over a list of :class:`BackupItem <azure.mgmt.web.v2016_08_01.models.BackupItem>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[BackupItem]'}
    }

    def __init__(self, *args, **kwargs):

        super(BackupItemPaged, self).__init__(*args, **kwargs)
class SiteConfigResourcePaged(Paged):
    """
    A paging container for iterating over a list of :class:`SiteConfigResource <azure.mgmt.web.v2016_08_01.models.SiteConfigResource>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[SiteConfigResource]'}
    }

    def __init__(self, *args, **kwargs):

        super(SiteConfigResourcePaged, self).__init__(*args, **kwargs)
class SiteConfigurationSnapshotInfoPaged(Paged):
    """
    A paging container for iterating over a list of :class:`SiteConfigurationSnapshotInfo <azure.mgmt.web.v2016_08_01.models.SiteConfigurationSnapshotInfo>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[SiteConfigurationSnapshotInfo]'}
    }

    def __init__(self, *args, **kwargs):

        super(SiteConfigurationSnapshotInfoPaged, self).__init__(*args, **kwargs)
class ContinuousWebJobPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ContinuousWebJob <azure.mgmt.web.v2016_08_01.models.ContinuousWebJob>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ContinuousWebJob]'}
    }

    def __init__(self, *args, **kwargs):

        super(ContinuousWebJobPaged, self).__init__(*args, **kwargs)
class DeploymentPaged(Paged):
    """
    A paging container for iterating over a list of :class:`Deployment <azure.mgmt.web.v2016_08_01.models.Deployment>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Deployment]'}
    }

    def __init__(self, *args, **kwargs):

        super(DeploymentPaged, self).__init__(*args, **kwargs)
class IdentifierPaged(Paged):
    """
    A paging container for iterating over a list of :class:`Identifier <azure.mgmt.web.v2016_08_01.models.Identifier>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Identifier]'}
    }

    def __init__(self, *args, **kwargs):

        super(IdentifierPaged, self).__init__(*args, **kwargs)
class FunctionEnvelopePaged(Paged):
    """
    A paging container for iterating over a list of :class:`FunctionEnvelope <azure.mgmt.web.v2016_08_01.models.FunctionEnvelope>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[FunctionEnvelope]'}
    }

    def __init__(self, *args, **kwargs):

        super(FunctionEnvelopePaged, self).__init__(*args, **kwargs)
class HostNameBindingPaged(Paged):
    """
    A paging container for iterating over a list of :class:`HostNameBinding <azure.mgmt.web.v2016_08_01.models.HostNameBinding>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[HostNameBinding]'}
    }

    def __init__(self, *args, **kwargs):

        super(HostNameBindingPaged, self).__init__(*args, **kwargs)
class SiteInstancePaged(Paged):
    """
    A paging container for iterating over a list of :class:`SiteInstance <azure.mgmt.web.v2016_08_01.models.SiteInstance>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[SiteInstance]'}
    }

    def __init__(self, *args, **kwargs):

        super(SiteInstancePaged, self).__init__(*args, **kwargs)
class ProcessInfoPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ProcessInfo <azure.mgmt.web.v2016_08_01.models.ProcessInfo>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ProcessInfo]'}
    }

    def __init__(self, *args, **kwargs):

        super(ProcessInfoPaged, self).__init__(*args, **kwargs)
class ProcessModuleInfoPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ProcessModuleInfo <azure.mgmt.web.v2016_08_01.models.ProcessModuleInfo>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ProcessModuleInfo]'}
    }

    def __init__(self, *args, **kwargs):

        super(ProcessModuleInfoPaged, self).__init__(*args, **kwargs)
class ProcessThreadInfoPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ProcessThreadInfo <azure.mgmt.web.v2016_08_01.models.ProcessThreadInfo>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ProcessThreadInfo]'}
    }

    def __init__(self, *args, **kwargs):

        super(ProcessThreadInfoPaged, self).__init__(*args, **kwargs)
class ResourceMetricDefinitionPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ResourceMetricDefinition <azure.mgmt.web.v2016_08_01.models.ResourceMetricDefinition>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ResourceMetricDefinition]'}
    }

    def __init__(self, *args, **kwargs):

        super(ResourceMetricDefinitionPaged, self).__init__(*args, **kwargs)
class ResourceMetricPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ResourceMetric <azure.mgmt.web.v2016_08_01.models.ResourceMetric>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ResourceMetric]'}
    }

    def __init__(self, *args, **kwargs):

        super(ResourceMetricPaged, self).__init__(*args, **kwargs)
class PerfMonResponsePaged(Paged):
    """
    A paging container for iterating over a list of :class:`PerfMonResponse <azure.mgmt.web.v2016_08_01.models.PerfMonResponse>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[PerfMonResponse]'}
    }

    def __init__(self, *args, **kwargs):

        super(PerfMonResponsePaged, self).__init__(*args, **kwargs)
class PublicCertificatePaged(Paged):
    """
    A paging container for iterating over a list of :class:`PublicCertificate <azure.mgmt.web.v2016_08_01.models.PublicCertificate>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[PublicCertificate]'}
    }

    def __init__(self, *args, **kwargs):

        super(PublicCertificatePaged, self).__init__(*args, **kwargs)
class SiteExtensionInfoPaged(Paged):
    """
    A paging container for iterating over a list of :class:`SiteExtensionInfo <azure.mgmt.web.v2016_08_01.models.SiteExtensionInfo>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[SiteExtensionInfo]'}
    }

    def __init__(self, *args, **kwargs):

        super(SiteExtensionInfoPaged, self).__init__(*args, **kwargs)
class SlotDifferencePaged(Paged):
    """
    A paging container for iterating over a list of :class:`SlotDifference <azure.mgmt.web.v2016_08_01.models.SlotDifference>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[SlotDifference]'}
    }

    def __init__(self, *args, **kwargs):

        super(SlotDifferencePaged, self).__init__(*args, **kwargs)
class SnapshotPaged(Paged):
    """
    A paging container for iterating over a list of :class:`Snapshot <azure.mgmt.web.v2016_08_01.models.Snapshot>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Snapshot]'}
    }

    def __init__(self, *args, **kwargs):

        super(SnapshotPaged, self).__init__(*args, **kwargs)
class TriggeredWebJobPaged(Paged):
    """
    A paging container for iterating over a list of :class:`TriggeredWebJob <azure.mgmt.web.v2016_08_01.models.TriggeredWebJob>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[TriggeredWebJob]'}
    }

    def __init__(self, *args, **kwargs):

        super(TriggeredWebJobPaged, self).__init__(*args, **kwargs)
class TriggeredJobHistoryPaged(Paged):
    """
    A paging container for iterating over a list of :class:`TriggeredJobHistory <azure.mgmt.web.v2016_08_01.models.TriggeredJobHistory>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[TriggeredJobHistory]'}
    }

    def __init__(self, *args, **kwargs):

        super(TriggeredJobHistoryPaged, self).__init__(*args, **kwargs)
class CsmUsageQuotaPaged(Paged):
    """
    A paging container for iterating over a list of :class:`CsmUsageQuota <azure.mgmt.web.v2016_08_01.models.CsmUsageQuota>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[CsmUsageQuota]'}
    }

    def __init__(self, *args, **kwargs):

        super(CsmUsageQuotaPaged, self).__init__(*args, **kwargs)
class WebJobPaged(Paged):
    """
    A paging container for iterating over a list of :class:`WebJob <azure.mgmt.web.v2016_08_01.models.WebJob>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[WebJob]'}
    }

    def __init__(self, *args, **kwargs):

        super(WebJobPaged, self).__init__(*args, **kwargs)
