# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.paging import Paged


class AppServiceEnvironmentResourcePaged(Paged):
    """
    A paging container for iterating over a list of :class:`AppServiceEnvironmentResource <azure.mgmt.web.v2016_09_01.models.AppServiceEnvironmentResource>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[AppServiceEnvironmentResource]'}
    }

    def __init__(self, *args, **kwargs):

        super(AppServiceEnvironmentResourcePaged, self).__init__(*args, **kwargs)
class StampCapacityPaged(Paged):
    """
    A paging container for iterating over a list of :class:`StampCapacity <azure.mgmt.web.v2016_09_01.models.StampCapacity>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[StampCapacity]'}
    }

    def __init__(self, *args, **kwargs):

        super(StampCapacityPaged, self).__init__(*args, **kwargs)
class ResourceMetricPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ResourceMetric <azure.mgmt.web.v2016_09_01.models.ResourceMetric>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ResourceMetric]'}
    }

    def __init__(self, *args, **kwargs):

        super(ResourceMetricPaged, self).__init__(*args, **kwargs)
class WorkerPoolResourcePaged(Paged):
    """
    A paging container for iterating over a list of :class:`WorkerPoolResource <azure.mgmt.web.v2016_09_01.models.WorkerPoolResource>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[WorkerPoolResource]'}
    }

    def __init__(self, *args, **kwargs):

        super(WorkerPoolResourcePaged, self).__init__(*args, **kwargs)
class ResourceMetricDefinitionPaged(Paged):
    """
    A paging container for iterating over a list of :class:`ResourceMetricDefinition <azure.mgmt.web.v2016_09_01.models.ResourceMetricDefinition>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[ResourceMetricDefinition]'}
    }

    def __init__(self, *args, **kwargs):

        super(ResourceMetricDefinitionPaged, self).__init__(*args, **kwargs)
class SkuInfoPaged(Paged):
    """
    A paging container for iterating over a list of :class:`SkuInfo <azure.mgmt.web.v2016_09_01.models.SkuInfo>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[SkuInfo]'}
    }

    def __init__(self, *args, **kwargs):

        super(SkuInfoPaged, self).__init__(*args, **kwargs)
class UsagePaged(Paged):
    """
    A paging container for iterating over a list of :class:`Usage <azure.mgmt.web.v2016_09_01.models.Usage>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Usage]'}
    }

    def __init__(self, *args, **kwargs):

        super(UsagePaged, self).__init__(*args, **kwargs)
class AppServicePlanPaged(Paged):
    """
    A paging container for iterating over a list of :class:`AppServicePlan <azure.mgmt.web.v2016_09_01.models.AppServicePlan>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[AppServicePlan]'}
    }

    def __init__(self, *args, **kwargs):

        super(AppServicePlanPaged, self).__init__(*args, **kwargs)
class SitePaged(Paged):
    """
    A paging container for iterating over a list of :class:`Site <azure.mgmt.web.v2016_09_01.models.Site>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[Site]'}
    }

    def __init__(self, *args, **kwargs):

        super(SitePaged, self).__init__(*args, **kwargs)
class CsmUsageQuotaPaged(Paged):
    """
    A paging container for iterating over a list of :class:`CsmUsageQuota <azure.mgmt.web.v2016_09_01.models.CsmUsageQuota>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[CsmUsageQuota]'}
    }

    def __init__(self, *args, **kwargs):

        super(CsmUsageQuotaPaged, self).__init__(*args, **kwargs)
class StrPaged(Paged):
    """
    A paging container for iterating over a list of str object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[str]'}
    }

    def __init__(self, *args, **kwargs):

        super(StrPaged, self).__init__(*args, **kwargs)
class HybridConnectionPaged(Paged):
    """
    A paging container for iterating over a list of :class:`HybridConnection <azure.mgmt.web.v2016_09_01.models.HybridConnection>` object
    """

    _attribute_map = {
        'next_link': {'key': 'nextLink', 'type': 'str'},
        'current_page': {'key': 'value', 'type': '[HybridConnection]'}
    }

    def __init__(self, *args, **kwargs):

        super(HybridConnectionPaged, self).__init__(*args, **kwargs)
