# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

try:
    from ._models_py3 import ApiDefinitionInfo
    from ._models_py3 import AppServicePlan
    from ._models_py3 import AutoHealActions
    from ._models_py3 import AutoHealCustomAction
    from ._models_py3 import AutoHealRules
    from ._models_py3 import AutoHealTriggers
    from ._models_py3 import AzureStorageInfoValue
    from ._models_py3 import Capability
    from ._models_py3 import Certificate
    from ._models_py3 import CertificatePatchResource
    from ._models_py3 import CloningInfo
    from ._models_py3 import ConnStringInfo
    from ._models_py3 import CorsSettings
    from ._models_py3 import DefaultErrorResponse, DefaultErrorResponseException
    from ._models_py3 import DefaultErrorResponseError
    from ._models_py3 import DefaultErrorResponseErrorDetailsItem
    from ._models_py3 import DeletedSite
    from ._models_py3 import Experiments
    from ._models_py3 import GeoDistribution
    from ._models_py3 import HandlerMapping
    from ._models_py3 import HostingEnvironmentProfile
    from ._models_py3 import HostNameSslState
    from ._models_py3 import HybridConnection
    from ._models_py3 import HybridConnectionKey
    from ._models_py3 import Identifier
    from ._models_py3 import IpSecurityRestriction
    from ._models_py3 import ManagedServiceIdentity
    from ._models_py3 import ManagedServiceIdentityUserAssignedIdentitiesValue
    from ._models_py3 import NameValuePair
    from ._models_py3 import ProxyOnlyResource
    from ._models_py3 import PushSettings
    from ._models_py3 import RampUpRule
    from ._models_py3 import RequestsBasedTrigger
    from ._models_py3 import Resource
    from ._models_py3 import ResourceMetricAvailability
    from ._models_py3 import ResourceMetricDefinition
    from ._models_py3 import Site
    from ._models_py3 import SiteConfig
    from ._models_py3 import SiteLimits
    from ._models_py3 import SiteMachineKey
    from ._models_py3 import SkuCapacity
    from ._models_py3 import SkuDescription
    from ._models_py3 import SlotSwapStatus
    from ._models_py3 import SlowRequestsBasedTrigger
    from ._models_py3 import Snapshot
    from ._models_py3 import StatusCodesBasedTrigger
    from ._models_py3 import User
    from ._models_py3 import VirtualApplication
    from ._models_py3 import VirtualDirectory
    from ._models_py3 import VnetGateway
    from ._models_py3 import VnetInfo
    from ._models_py3 import VnetRoute
except (SyntaxError, ImportError):
    from ._models import ApiDefinitionInfo
    from ._models import AppServicePlan
    from ._models import AutoHealActions
    from ._models import AutoHealCustomAction
    from ._models import AutoHealRules
    from ._models import AutoHealTriggers
    from ._models import AzureStorageInfoValue
    from ._models import Capability
    from ._models import Certificate
    from ._models import CertificatePatchResource
    from ._models import CloningInfo
    from ._models import ConnStringInfo
    from ._models import CorsSettings
    from ._models import DefaultErrorResponse, DefaultErrorResponseException
    from ._models import DefaultErrorResponseError
    from ._models import DefaultErrorResponseErrorDetailsItem
    from ._models import DeletedSite
    from ._models import Experiments
    from ._models import GeoDistribution
    from ._models import HandlerMapping
    from ._models import HostingEnvironmentProfile
    from ._models import HostNameSslState
    from ._models import HybridConnection
    from ._models import HybridConnectionKey
    from ._models import Identifier
    from ._models import IpSecurityRestriction
    from ._models import ManagedServiceIdentity
    from ._models import ManagedServiceIdentityUserAssignedIdentitiesValue
    from ._models import NameValuePair
    from ._models import ProxyOnlyResource
    from ._models import PushSettings
    from ._models import RampUpRule
    from ._models import RequestsBasedTrigger
    from ._models import Resource
    from ._models import ResourceMetricAvailability
    from ._models import ResourceMetricDefinition
    from ._models import Site
    from ._models import SiteConfig
    from ._models import SiteLimits
    from ._models import SiteMachineKey
    from ._models import SkuCapacity
    from ._models import SkuDescription
    from ._models import SlotSwapStatus
    from ._models import SlowRequestsBasedTrigger
    from ._models import Snapshot
    from ._models import StatusCodesBasedTrigger
    from ._models import User
    from ._models import VirtualApplication
    from ._models import VirtualDirectory
    from ._models import VnetGateway
    from ._models import VnetInfo
    from ._models import VnetRoute
from ._paged_models import CertificatePaged
from ._web_site_management_client_enums import (
    KeyVaultSecretStatus,
    RouteType,
    ManagedServiceIdentityType,
    IpFilterTag,
    AutoHealActionType,
    ConnectionStringType,
    AzureStorageType,
    AzureStorageState,
    ScmType,
    ManagedPipelineMode,
    SiteLoadBalancing,
    SupportedTlsVersions,
    FtpsState,
    SslState,
    HostType,
    UsageState,
    SiteAvailabilityState,
    RedundancyMode,
    StatusOptions,
    ProvisioningState,
)

__all__ = [
    'ApiDefinitionInfo',
    'AppServicePlan',
    'AutoHealActions',
    'AutoHealCustomAction',
    'AutoHealRules',
    'AutoHealTriggers',
    'AzureStorageInfoValue',
    'Capability',
    'Certificate',
    'CertificatePatchResource',
    'CloningInfo',
    'ConnStringInfo',
    'CorsSettings',
    'DefaultErrorResponse', 'DefaultErrorResponseException',
    'DefaultErrorResponseError',
    'DefaultErrorResponseErrorDetailsItem',
    'DeletedSite',
    'Experiments',
    'GeoDistribution',
    'HandlerMapping',
    'HostingEnvironmentProfile',
    'HostNameSslState',
    'HybridConnection',
    'HybridConnectionKey',
    'Identifier',
    'IpSecurityRestriction',
    'ManagedServiceIdentity',
    'ManagedServiceIdentityUserAssignedIdentitiesValue',
    'NameValuePair',
    'ProxyOnlyResource',
    'PushSettings',
    'RampUpRule',
    'RequestsBasedTrigger',
    'Resource',
    'ResourceMetricAvailability',
    'ResourceMetricDefinition',
    'Site',
    'SiteConfig',
    'SiteLimits',
    'SiteMachineKey',
    'SkuCapacity',
    'SkuDescription',
    'SlotSwapStatus',
    'SlowRequestsBasedTrigger',
    'Snapshot',
    'StatusCodesBasedTrigger',
    'User',
    'VirtualApplication',
    'VirtualDirectory',
    'VnetGateway',
    'VnetInfo',
    'VnetRoute',
    'CertificatePaged',
    'KeyVaultSecretStatus',
    'RouteType',
    'ManagedServiceIdentityType',
    'IpFilterTag',
    'AutoHealActionType',
    'ConnectionStringType',
    'AzureStorageType',
    'AzureStorageState',
    'ScmType',
    'ManagedPipelineMode',
    'SiteLoadBalancing',
    'SupportedTlsVersions',
    'FtpsState',
    'SslState',
    'HostType',
    'UsageState',
    'SiteAvailabilityState',
    'RedundancyMode',
    'StatusOptions',
    'ProvisioningState',
]
